#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five4004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five4004xi = {
                1: '-100x124y366z',
                2: '-102x266y280z',
                3: '-102x361y136z',
                4: '-109x121y364z',
                5: '-111x243y297z',
                6: '-117x118y363z',
                7: '-117x263y277z',
                8: '-121x357y133z',
                9: '-125x239y294z',
                10: '-126x114y361z',
                11: '-12x118y381z',
                12: '-12x2y399z',
                13: '-131x259y274z',
                14: '-135x110y359z',
                15: '-139x235y291z',
                16: '-140x351y129z',
                17: '-143x105y358z',
                18: '-146x254y271z',
                19: '-152x99y356z',
                20: '-153x229y289z',
                21: '-159x344y125z',
                22: '-160x93y354z',
                23: '-161x248y268z',
                24: '-166x223y286z',
                25: '-167x86y352z',
                26: '-16x2y399z',
                27: '-175x241y265z',
                28: '-175x78y350z',
                29: '-177x337y121z',
                30: '-180x216y283z',
                31: '-182x70y348z',
                32: '-189x234y262z',
                33: '-189x62y346z',
                34: '-18x121y380z',
                35: '-193x209y280z',
                36: '-195x328y117z',
                37: '-195x53y344z',
                38: '-201x43y342z',
                39: '-203x225y259z',
                40: '-205x200y277z',
                41: '-206x33y340z',
                42: '-20x2y399z',
                43: '-211x22y338z',
                44: '-213x318y114z',
                45: '-216x12y336z',
                46: '-216x216y256z',
                47: '-218x191y275z',
                48: '-219x0y334z',
                49: '-229x206y253z',
                50: '-230x181y272z',
                51: '-230x307y110z',
                52: '-241x170y269z',
                53: '-242x196y250z',
                54: '-246x296y106z',
                55: '-24x1y399z',
                56: '-252x159y266z',
                57: '-254x184y247z',
                58: '-25x123y379z',
                59: '-262x147y263z',
                60: '-262x283y102z',
                61: '-265x172y244z',
                62: '-272x134y260z',
                63: '-276x159y241z',
                64: '-277x270y98z',
                65: '-281x121y257z',
                66: '-286x145y237z',
                67: '-289x107y254z',
                68: '-28x0y398z',
                69: '-28x269y294z',
                70: '-292x256y94z',
                71: '-295x131y234z',
                72: '-297x92y250z',
                73: '-304x116y231z',
                74: '-304x77y247z',
                75: '-306x241y90z',
                76: '-310x61y244z',
                77: '-312x101y228z',
                78: '-315x45y241z',
                79: '-318x225y87z',
                80: '-319x29y238z',
                81: '-319x85y224z',
                82: '-323x12y235z',
                83: '-325x69y221z',
                84: '-331x208y83z',
                85: '-331x52y218z',
                86: '-335x35y214z',
                87: '-339x17y211z',
                88: '-33x125y378z',
                89: '-341x0y208z',
                90: '-342x191y79z',
                91: '-352x173y75z',
                92: '-361x155y71z',
                93: '-369x136y67z',
                94: '-377x116y63z',
                95: '-383x97y59z',
                96: '-388x77y55z',
                97: '-392x56y51z',
                98: '-395x36y47z',
                99: '-397x15y43z',
                100: '-40x127y376z',
                101: '-42x248y310z',
                102: '-42x270y291z',
                103: '-43x368y148z',
                104: '-48x128y375z',
                105: '-4x1y399z',
                106: '-56x249y307z',
                107: '-57x129y374z',
                108: '-57x270y288z',
                109: '-63x367y144z',
                110: '-65x129y372z',
                111: '-69x248y305z',
                112: '-72x269y286z',
                113: '-74x129y371z',
                114: '-82x128y369z',
                115: '-82x365y140z',
                116: '-83x247y302z',
                117: '-87x268y283z',
                118: '-8x2y399z',
                119: '-91x126y368z',
                120: '-92x491y9z',
                121: '-97x245y300z',
                122: '0x0y399z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire400five4xi" usage = "target function for charge4004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire400five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five4004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five4004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE400FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400five4xi.py                             
# -------------------------------------------------------------------------------------------------                